/*
 * Sistemas de Tempo Real, 2003/2004
 * Luis Almeida & Paulo Pedreiras
 * Oct.2003
 * 
 * aula3: Linux/RTAI
 * 4 RT tasks toggle a bit on the paralell port.
 * Bit status is sent to rt fifo
 * Linux task reads rt fifo and displays pin status
 *
 * Application parameters
 *
 */

typedef struct {
  long long evt_time;
  unsigned char task_id;
  unsigned char task_act;
} Task_Evt;

#define USE_FPU 1        /* Uses FPU flag */

#define NUM_TASKS 4      /* Number of RT tasks */
#define LPT_ADDR 0x378   /* Address of data register of paralell port */
#define FIFO 0           /* FIFO id (RTAI) */
#define FIFO_SIZE 8000   /* FIFO Size (RTAI) */

#define PERIOD 1000000   /* Tasks base period in ns (RTAI) */
#define STACK_SIZE 3000  /* Tasks's stack size (RTAI) */

#define DISP_STEP (10*1000000L) /* Display step (100ms) */


/* Task characterization: period in ms*/
#define TASK0_PERIOD 1000
#define TASK1_PERIOD 2333
#define TASK2_PERIOD 3555
#define TASK3_PERIOD 4777

/* rt_busy_sleep arg in ns */
#define MS2NS 1000000L
#define TASK0_LOAD  (100L*MS2NS)
#define TASK1_LOAD  (250L*MS2NS)
#define TASK2_LOAD  (500L*MS2NS)
#define TASK3_LOAD (1000L*MS2NS)


