/* *******************************************************
   Sistemas de Tempo Real, 2003/2004
   Luis Almeida & Paulo Pedreiras
   Oct.2003
   
   aula3: Linux/RTAI
   4 RT tasks toggle a bit on the paralell port.
   Bit status is sent to rt fifo
   Linux task reads rt fifo and displays pin status

   Linux display module

   ******************************************************* */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>

#include <errno.h>
#include <fcntl.h>
#include <sched.h>
#include <signal.h>

#include "app_defs.h"

static int end=0;
static Task_Evt tevt;
unsigned long oldtime=0;

static void endme(int dummy)
{
  end=1;
}

int main(void)
{
  struct sched_param proc_sched;
  int ff; 
  unsigned char task_stat[NUM_TASKS];
  int nt,j=0;

  /* Info message */
  printf("\n Hit CTRL+C to stop\n");

  /* Init vars */
  for(nt=0;nt<NUM_TASKS;nt++)
    task_stat[nt]=0;

  /* Catches CTRL+C and end the program */
  signal (SIGINT, endme);

#ifdef SU
  /* Set the process priority and scheduling policy */
  proc_sched.sched_priority=99;

  if( sched_setscheduler(0,SCHED_FIFO,&proc_sched) == -1) {
    puts("\n Error in setting the scheduler!");
    perror("Errno");
    exit(1);
  }
#endif

  /* Opens the fifo */
  if( (ff=open("/dev/rtf0",O_RDONLY))<0){
    fprintf(stderr,"\n Fatal error opening /dev/rtf0");
    exit(2);
  }
  
  /* Main loop: reads fifo and updates the screen */
  while(!end) {
    read(ff,&tevt,sizeof(tevt));
    
    if(tevt.task_act == 's')
      task_stat[tevt.task_id]=1;
    else
      task_stat[tevt.task_id]=0;
    
    if(tevt.evt_time-oldtime > 0 /*DISP_STEP*/ ){
      printf("\n [%5d] ",j);
      for(nt=0;nt<NUM_TASKS;nt++){
	if(task_stat[nt] == 0)
	  printf("| ");
	else
	  printf(" |");
	printf("   ");
      }
      oldtime=tevt.evt_time;
      j++;
    }
  }
  
  close(ff);
  
  return 0;
  

}
